// i7540DWF_demoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "i7540DWF_demo.h"
#include "i7540DWF_demoDlg.h"

#include "VCI_CAN.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

DWORD Total_RxMsgCnt=0;

//Timer
#define TIMER_001 1

/////////////////////////////////////////////////////////////////////////////
// CI7540DWF_demoDlg dialog

CI7540DWF_demoDlg::CI7540DWF_demoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CI7540DWF_demoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CI7540DWF_demoDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CI7540DWF_demoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CI7540DWF_demoDlg)
	DDX_Control(pDX, IDC_CHECK1, m_check1);
	DDX_Control(pDX, IDC_EDIT_D8, m_TxD8);
	DDX_Control(pDX, IDC_EDIT_D7, m_TxD7);
	DDX_Control(pDX, IDC_EDIT_D6, m_TxD6);
	DDX_Control(pDX, IDC_EDIT_D5, m_TxD5);
	DDX_Control(pDX, IDC_EDIT_D4, m_TxD4);
	DDX_Control(pDX, IDC_EDIT_D3, m_TxD3);
	DDX_Control(pDX, IDC_EDIT_D2, m_TxD2);
	DDX_Control(pDX, IDC_EDIT_D1, m_TxD1);
	DDX_Control(pDX, IDC_EDIT_RTR, m_TxRTR);
	DDX_Control(pDX, IDC_EDIT_DLC, m_TxDLC);
	DDX_Control(pDX, IDC_EDIT_ID, m_TxID);
	DDX_Control(pDX, IDC_LIST1, m_listbox);
	DDX_Control(pDX, IDC_S_IPADDR, m_S_IpAddr);
	DDX_Control(pDX, IDC_EDIT_PORT, m_TCPPort);
	DDX_Control(pDX, IDC_C_IPADDR, m_C_IpAddr);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CI7540DWF_demoDlg, CDialog)
	//{{AFX_MSG_MAP(CI7540DWF_demoDlg)
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_LISTEN, OnBtnListen)
	ON_BN_CLICKED(IDC_CloseSocket, OnCloseSocket)
	ON_BN_CLICKED(IDC_BTN_CONNECT, OnBtnConnect)
	ON_BN_CLICKED(IDC_BUT_SENDCANMSG, OnButSendcanmsg)
	ON_BN_CLICKED(IDC_BUT_RECEIVECANMSG, OnButReceivecanmsg)
	ON_BN_CLICKED(IDC_BUT_CLEARMSG, OnButClearmsg)
	ON_BN_CLICKED(IDC_BUT_RECEIVESTOP, OnButReceivestop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CI7540DWF_demoDlg message handlers

BOOL CI7540DWF_demoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	BYTE localIPaddr[4]  = {192,168,255,1};
	m_C_IpAddr.SetAddress(localIPaddr[0],localIPaddr[1],localIPaddr[2],localIPaddr[3]);
	m_S_IpAddr.SetAddress(localIPaddr[0],localIPaddr[1],localIPaddr[2],localIPaddr[3]);

	m_TCPPort.SetWindowText("10000");

	m_TxID.SetWindowText("1FF");
	m_TxRTR.SetWindowText("0");
	m_TxRTR.SetLimitText(1);
	m_TxDLC.SetWindowText("8");
	m_TxD1.SetWindowText("12");
	m_TxD2.SetWindowText("34");
	m_TxD3.SetWindowText("56");
	m_TxD4.SetWindowText("78");
	m_TxD5.SetWindowText("90");
	m_TxD6.SetWindowText("AB");
	m_TxD7.SetWindowText("CD");
	m_TxD8.SetWindowText("EF");

	((CButton*)GetDlgItem(IDC_BUT_RECEIVESTOP))->EnableWindow(FALSE);

	UpdateData(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CI7540DWF_demoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CI7540DWF_demoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CI7540DWF_demoDlg::OnBtnListen()
{
	// TODO: Add your control notification handler code here
	
	DWORD u32_IP, WaitTime;
	char temp[20];
	unsigned short ms32_Port;

  	UpdateData(TRUE); // Load ms_Send and ms32_Port

	m_C_IpAddr.GetAddress(u32_IP);

	m_TCPPort.GetWindowText(temp,20);
	temp[20]=0;
	if (strlen(temp)==0) return;

	ms32_Port = atoi(temp);

	DWORD u32_Err = I7540DWF_ServerListen(u32_IP, ms32_Port);

	if (u32_Err){
		MessageBox("Listen Error", NULL, MB_OK);
	}
	else{
		MessageBox("Waiting for ACCEPT", NULL, MB_OK);

		WaitTime = GetTickCount();
		
	    while(true){
			if(!I7540DWF_Get_CntStatus()){
				if((GetTickCount() - WaitTime) >= 10000){
					MessageBox("ACCEPT TimeOut", NULL, MB_OK);
					I7540DWF_CloseSockets();
					break;
				}
			}
			else{
				MessageBox("ACCEPT OK", NULL, MB_OK);
				break;
			}
			I7540DWF_DoEvents();
		}
	}
}

void CI7540DWF_demoDlg::OnCloseSocket() 
{
	// TODO: Add your control notification handler code here
	I7540DWF_CloseSockets();
}

void CI7540DWF_demoDlg::OnBtnConnect() 
{
	// TODO: Add your control notification handler code here

	DWORD u32_IP;
	char temp[20];
	unsigned short ms32_Port;

	UpdateData(TRUE); // Load ms_Send and ms32_Port

	m_S_IpAddr.GetAddress(u32_IP);

	m_TCPPort.GetWindowText(temp,20);
	temp[20]=0;
	if (strlen(temp)==0) return;

	ms32_Port = atoi(temp);

	DWORD u32_Err = I7540DWF_ClientConnect(u32_IP, ms32_Port);

	if(u32_Err == 0)
		MessageBox("Connection to Server OK", NULL, MB_OK);
	else
		MessageBox("Connection to Server Error", NULL, MB_OK);
}

void CI7540DWF_demoDlg::OnButSendcanmsg() 
{
	// TODO: Add your control notification handler code here
	CANStruct TxCanPacket;

	char TempTxBuf[20];
	char *endptr;
	CString text;

	//[1] Mode
	if (m_check1.GetCheck() == 1){
		TxCanPacket.mode = 1;
	}
	else{
		TxCanPacket.mode = 0;
	}
 
	//[2] ID
	if(TxCanPacket.mode == 0){
		m_TxID.GetWindowText(TempTxBuf,4);
		TxCanPacket.id = strtoul(TempTxBuf,&endptr,16);
		if (TxCanPacket.id > 0x7FF){
			MessageBox(_T("ID  error!"),NULL,NULL);
			return;
		}
	}
	else{
		m_TxID.GetWindowText(TempTxBuf,9);
		TxCanPacket.id = strtoul(TempTxBuf,&endptr,16);
		if (TxCanPacket.id > 0x1FFFFFFF){
			MessageBox(_T("ID  error!"),NULL,NULL);
			return;
		}
	}

	//[3] RTR
	m_TxRTR.GetWindowText(TempTxBuf,2);
	TxCanPacket.rtr = (BYTE)strtol(TempTxBuf,&endptr,16);
	if(TxCanPacket.rtr>1){
		MessageBox(_T("RTR  error!"),NULL,NULL);
		return;
	}

	//[4] DLC
	m_TxDLC.GetWindowText(TempTxBuf,2);
	TxCanPacket.len = (BYTE)strtol(TempTxBuf,&endptr,16);
	if(TxCanPacket.len>8){
		MessageBox(_T("DLC  error!"),NULL,NULL);
		return;
	}
  
	//[5] Data[0] ~ Data[7]
	m_TxD1.GetWindowText(TempTxBuf,20);
	TxCanPacket.data[0] = (BYTE)strtol(TempTxBuf,&endptr,16);
	m_TxD2.GetWindowText(TempTxBuf,20);
	TxCanPacket.data[1] = (BYTE)strtol(TempTxBuf,&endptr,16);
	m_TxD3.GetWindowText(TempTxBuf,20);
	TxCanPacket.data[2] = (BYTE)strtol(TempTxBuf,&endptr,16);
	m_TxD4.GetWindowText(TempTxBuf,20);
	TxCanPacket.data[3] = (BYTE)strtol(TempTxBuf,&endptr,16);
	m_TxD5.GetWindowText(TempTxBuf,20);
	TxCanPacket.data[4] = (BYTE)strtol(TempTxBuf,&endptr,16);
	m_TxD6.GetWindowText(TempTxBuf,20);
	TxCanPacket.data[5] = (BYTE)strtol(TempTxBuf,&endptr,16);
	m_TxD7.GetWindowText(TempTxBuf,20);
	TxCanPacket.data[6] = (BYTE)strtol(TempTxBuf,&endptr,16);
	m_TxD8.GetWindowText(TempTxBuf,20);
	TxCanPacket.data[7] = (BYTE)strtol(TempTxBuf,&endptr,16);

	I7540DWF_SendCANMsg(0, TxCanPacket);
}

void CI7540DWF_demoDlg::OnButReceivecanmsg()
{
	// TODO: Add your control notification handler code here

	SetTimer(TIMER_001,100,NULL);	
	((CButton*)GetDlgItem(IDC_BUT_RECEIVECANMSG))->EnableWindow(FALSE);
	((CButton*)GetDlgItem(IDC_BUT_RECEIVESTOP))->EnableWindow(TRUE);
}

void CI7540DWF_demoDlg::OnButClearmsg() 
{
	// TODO: Add your control notification handler code here
    if(m_listbox.GetCount()>0){
        m_listbox.ResetContent();
	}
    Total_RxMsgCnt = 0;	
}


void CI7540DWF_demoDlg::OnTimer(UINT nIDEvent) 
{
		
	// TODO: Add your message handler code here and/or call default
	CDialog::OnTimer(nIDEvent);

	switch(nIDEvent)
	{
	    case TIMER_001:
		
		RecvCANMsg();

	    break;
	}
}


void CI7540DWF_demoDlg::OnButReceivestop() 
{
	// TODO: Add your control notification handler code here
	KillTimer(TIMER_001);

	((CButton*)GetDlgItem(IDC_BUT_RECEIVECANMSG))->EnableWindow(TRUE);
	((CButton*)GetDlgItem(IDC_BUT_RECEIVESTOP))->EnableWindow(FALSE);
}


void CI7540DWF_demoDlg::RecvCANMsg()
{
    char Temp[200];
	double timestamp;
	CANStruct RxCanPacket={0};
	DWORD MsgCount=0;

	MsgCount = I7540DWF_Get_RxMsgCnt();

	for(DWORD i=0; i<MsgCount; i++)
	{
		if(I7540DWF_RecvCANMsg(&RxCanPacket)==0){

			timestamp = (double)RxCanPacket.MsgTimeStamps;

			sprintf(Temp,"No.%07lu    Mode:%d    ID:%08X    RTR:%d    DLC:%d    Data(hex):%02X %02X %02X %02X %02X %02X %02X %02X    TimeStamp=%f",
					1+Total_RxMsgCnt,RxCanPacket.mode,RxCanPacket.id,RxCanPacket.rtr,RxCanPacket.len,
					RxCanPacket.data[0],RxCanPacket.data[1],RxCanPacket.data[2],RxCanPacket.data[3],
					RxCanPacket.data[4],RxCanPacket.data[5],RxCanPacket.data[6],RxCanPacket.data[7],timestamp/1000);
						
			m_listbox.AddString(Temp);

			Total_RxMsgCnt++;
		}
		I7540DWF_DoEvents();
	}

	m_listbox.SetTopIndex(Total_RxMsgCnt-9);
}
